using System;
using System.Collections.Generic;
using System.Text;

using System.Data;
using Server.DB;

namespace Server
{
	class CustomClassServer:MarshalByRefObject 
	{
		private DBHelper _helper = new DBHelper();

		#region FetchDataByReader
		private IDataReader FetchDataViaReader(int id, IDbCommand cmd)
		{
			try
			{
				cmd.Connection.Open();
				return cmd.ExecuteReader(CommandBehavior.CloseConnection);
			}
			finally
			{
				if (cmd.Connection.State == ConnectionState.Open)
				{
					cmd.Connection.Close();
				}
			}
		}

		private IDataReader FetchOrderViaReader(int id)
		{
			return this.FetchDataViaReader(id, this._helper.GetFetchOrderCommand(id));
		}

		private IDataReader FetchLinesViaReader(int id)
		{
			return this.FetchDataViaReader(id, this._helper.GetFetchLinesCommand(id));
		}

		private IDataReader FetchOrderAndLinesViaReader(int id)
		{
			return this.FetchDataViaReader(id, this._helper.GetFetchOrderAndLinesCommand(id));
		}

		#endregion
//
//		public  FetchOrder(int id)
//		{
//
//		}

	}
}
