using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

using Server.DB;

namespace Server
{
	class DatasetServer:MarshalByRefObject 
	{
		private DBHelper _helper = new DBHelper();

		public DataSet FetchOrderViaDS(int id)
		{
			DataSet ds = new DataSet();

			SqlDataAdapter anAdapter = new SqlDataAdapter(this._helper.GetFetchOrderCommand(id));

			anAdapter.TableMappings.Add("Table", "Orders");
			anAdapter.TableMappings["Orders"].ColumnMappings.Add("Customer_Id", "CustomerId");
			anAdapter.Fill(ds);

			ds.RemotingFormat = SerializationFormat.Binary;

			return ds;
		}

		public DataSet FetchLinesViaDs(int id)
		{
			DataSet ds = new DataSet();

			SqlDataAdapter anAdapter = new SqlDataAdapter(this._helper.GetFetchLinesCommand(id));

			anAdapter.TableMappings.Add("Table", "OrderLines");
			anAdapter.TableMappings["OrderLines"].ColumnMappings.Add("Orders_Id", "OrderId");
			anAdapter.TableMappings["OrderLines"].ColumnMappings.Add("Product_Id", "ProductId");
			anAdapter.Fill(ds);

			ds.RemotingFormat = SerializationFormat.Binary;

			return ds;
		}

		public DataSet FetchOrderAndLinesViaDS(int id)
		{
			DataSet ds = new DataSet();

			SqlDataAdapter anAdapter = new SqlDataAdapter(this._helper.GetFetchOrderAndLinesCommand(id));

			anAdapter.TableMappings.Add("Table", "Orders");
			anAdapter.TableMappings.Add("Table1", "OrderLines");

			anAdapter.TableMappings["Orders"].ColumnMappings.Add("Customer_Id", "CustomerId");
			anAdapter.TableMappings["OrderLines"].ColumnMappings.Add("Orders_Id", "OrderId");
			anAdapter.TableMappings["OrderLines"].ColumnMappings.Add("Product_Id", "ProductId");
			anAdapter.Fill(ds);

			ds.RemotingFormat = SerializationFormat.Binary;

			return ds;
		}
	}
}
