///
///author: linkcd
///date: 2005-08-30
///

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

using Server.DB;
using Entity;

namespace Server
{
	/// <summary>
	/// this server return custom classes as business entity
	/// </summary>
	public class CustomClassServer : MarshalByRefObject, IRemotingServer
	{
		private DBHelper _helper = new DBHelper();

		#region FetchDataByReader
		private SqlDataReader FetchDataViaReader(int id, SqlCommand  cmd)
		{
			cmd.Connection.Open();
			return cmd.ExecuteReader(CommandBehavior.CloseConnection);
		}

		private SqlDataReader FetchOrderViaReader(int id)
		{
			return this.FetchDataViaReader(id, this._helper.GetFetchOrderCommand(id));
		}

		private SqlDataReader FetchLinesViaReader(int id, int countOfRecords)
		{
			return this.FetchDataViaReader(id, this._helper.GetFetchLinesCommand(id, countOfRecords));
		}

		private SqlDataReader FetchOrderAndLinesViaReader(int id, int countOfRecords)
		{
			return this.FetchDataViaReader(id, this._helper.GetFetchOrderAndLinesCommand(id, countOfRecords));
		}

		#endregion

		#region IRemotingServer Members

		object IRemotingServer.FetchOrder(int id)
		{
			SqlDataReader aDataReader = this.FetchOrderViaReader(id);

			Order anOrder = new Order();
			aDataReader.Read();

			anOrder.Id = aDataReader.GetInt32((int)OrderColumns.Id);
			anOrder.CustomerId = aDataReader.GetInt32((int)OrderColumns.CustomerId);
			anOrder.OrderDate = aDataReader.GetDateTime((int)OrderColumns.OrderDate);

			aDataReader.Close();
			return anOrder;
		}

		object IRemotingServer.FetchOrderLines(int id, int countOfRecords)
		{
			SqlDataReader aDataReader = (SqlDataReader)this.FetchLinesViaReader(id, countOfRecords);

			OrderLines theOrderLines = new OrderLines();
			while (aDataReader.Read())
			{
				OrderLine anOrderLine = new OrderLine();
				anOrderLine.ProductId = aDataReader.GetInt32((int)OrderLineColumns.ProductId);
				anOrderLine.PriceForEach = aDataReader.GetSqlMoney((int)OrderLineColumns.PriceForEach).ToDecimal();
				anOrderLine.NoOfItems = aDataReader.GetInt32((int)OrderLineColumns.NoOfItems);
				anOrderLine.Comment = aDataReader.GetString((int)OrderLineColumns.Comment);
				theOrderLines.Add(anOrderLine);
			}

			aDataReader.Close();
			return theOrderLines;
		}

		public object FetchOrderAndLines(int id, int countOfRecords)
		{
			SqlDataReader aDataReader = this.FetchOrderAndLinesViaReader(id, countOfRecords);

			Order anOrder = new Order();
			aDataReader.Read();

			anOrder.Id = aDataReader.GetInt32((int)OrderColumns.Id);
			anOrder.CustomerId = aDataReader.GetInt32((int)OrderColumns.CustomerId);
			anOrder.OrderDate = aDataReader.GetDateTime((int)OrderColumns.OrderDate);

			aDataReader.NextResult();
			while (aDataReader.Read())
			{
				OrderLine anOrderLine = new OrderLine();
				anOrderLine.ProductId = aDataReader.GetInt32((int)OrderLineColumns.ProductId);
				anOrderLine.PriceForEach = aDataReader.GetSqlMoney((int)OrderLineColumns.PriceForEach).ToDecimal();
				anOrderLine.NoOfItems = aDataReader.GetInt32((int)OrderLineColumns.NoOfItems);
				anOrderLine.Comment = aDataReader.GetString((int)OrderLineColumns.Comment);
				anOrder.Lines.Add(anOrderLine);
			}

			aDataReader.Close();
			return anOrder;
		}

		#endregion
}
}
