///
///author: linkcd
///date: 2005-08-30
///

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

using Server.DB;

namespace Server
{	
	/// <summary>
	/// this server return dataset as business entity
	/// </summary>
	public class DatasetServer : MarshalByRefObject, IRemotingServer
	{
		private bool _isBinary;

		/// <summary>
		/// constructor
		/// </summary>
		/// <param name="IsBinarySerialze">specify if the dataset serializ as xml or binary style</param>
		public DatasetServer(bool IsBinarySerialze)
		{
			this._isBinary = IsBinarySerialze;
		}

		private DBHelper _helper = new DBHelper();

		#region IRemotingServer Members

		public object FetchOrder(int id)
		{
			DataSet ds = new DataSet();

			SqlDataAdapter anAdapter = new SqlDataAdapter(this._helper.GetFetchOrderCommand(id));

			anAdapter.TableMappings.Add("Table", "Orders");
			anAdapter.TableMappings["Table"].ColumnMappings.Add("Customer_Id", "CustomerId");
			anAdapter.Fill(ds);

			if (this._isBinary)
			{
				ds.RemotingFormat = SerializationFormat.Binary;
			}

			return ds;
		}

		public object FetchOrderLines(int id,int countOfRecords)
		{
			DataSet ds = new DataSet();

			SqlDataAdapter anAdapter = new SqlDataAdapter(this._helper.GetFetchLinesCommand(id, countOfRecords));

			anAdapter.TableMappings.Add("Table", "OrderLines");
			anAdapter.TableMappings["Table"].ColumnMappings.Add("Orders_Id", "OrderId");
			anAdapter.TableMappings["Table"].ColumnMappings.Add("Product_Id", "ProductId");
			anAdapter.Fill(ds);

			if (this._isBinary)
			{
				ds.RemotingFormat = SerializationFormat.Binary;
			}

			return ds;
		}

		public object FetchOrderAndLines(int id, int countOfRecords)
		{
			DataSet ds = new DataSet();

			SqlDataAdapter anAdapter = new SqlDataAdapter(this._helper.GetFetchOrderAndLinesCommand(id, countOfRecords));

			anAdapter.TableMappings.Add("Table", "Orders");
			anAdapter.TableMappings.Add("Table1", "OrderLines");

			anAdapter.TableMappings["Table"].ColumnMappings.Add("Customer_Id", "CustomerId");
			anAdapter.TableMappings["Table1"].ColumnMappings.Add("Orders_Id", "OrderId");
			anAdapter.TableMappings["Table1"].ColumnMappings.Add("Product_Id", "ProductId");
			anAdapter.Fill(ds);

			if (this._isBinary)
			{
				ds.RemotingFormat = SerializationFormat.Binary;
			}

			return ds;
		}

		#endregion
}
}
